#pragma once

#include "wimp_basics.h"
#include "wimp_icons.h"

#ifdef __cplusplus
extern "C"
{
#endif

  typedef struct tMenu tMenu_t; // m

  typedef struct
  {
    unsigned mfDisplayTick : 1;
    unsigned mfDottedLine : 1;
    unsigned mfWriteable : 1;
    unsigned mfSubmenuMessage : 1;
    unsigned mfOpenIfGreyed : 1;
    unsigned : 2;
    unsigned mfLastItem : 1;
    unsigned mfTitleIsIndirectText : 1;
    unsigned : 21;
  } sMenuFlags; // mf

  typedef struct
  {
    union
    {
      sMenuFlags mfMenuFlags;
      unsigned int uiMenuFlags;
    };
    union
    {
      const tMenu_t* mSubmenu;
      tWindowHandle whWindow;
    };
    union
    {
      sIconFlags ifMenuIconFlags;
      unsigned int uiMenuIconFlags;
    };
    uIconData idMenuIconData;
  } tMenuItem; // mi

  typedef struct tMenu
  {
    union
    {
      char caTitle[12];
      struct
      {
        const char* kpcaTitle;
        const char* kpcaValidation;
        int iTitleLength;
      };
    };
    struct
    {
      unsigned bTitleForegroundColour : 8;
      unsigned bTitleBackgroundColour : 8;
      unsigned bWorkAreaForegroundColour : 8;
      unsigned bWorkAreaBackgroundColour : 8;
    };
    tCoordinate cMenuItemWidth;
    tCoordinate cMenuItemHeight;
    tCoordinate cVerticalGap;
    tMenuItem miMenuItems[0];
  } tMenu; // m

  /*! Creates a menu
  \param kpmMenu The menu structure
  \param cX The X coordinate
  \param cY The Y coordinate
  \return 0 if an error occurred
  */
  int wimp_createmenu(const tMenu* kpmMenu, tCoordinate cX, tCoordinate cY);

  /*! Closes a menu
  \param kpmMenu The menu structure
  \param cX The X coordinate
  \param cY The Y coordinate
  \return 0 if an error occurred
  */
  int wimp_closemenu(void);

#ifdef __cplusplus
}
#endif
